This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 871153 - systemd prints unprintable characters to serial console
systemd prints unprintable characters to serial console
Status: NEW
Product: Fedora
Classification: Fedora
Component: minicom (Show other bugs)
23
All Linux
low Severity low
: ---
: ---
Assigned To: Jaromír Cápík
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks: ARMTracker
  Show dependency treegraph
 
Reported: 2012-10-29 14:41 EDT by Jeff Bastian
Modified: 2016-01-31 21:03 EST (History)
10 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-02-18 08:46:45 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Jeff Bastian 2012-10-29 14:41:02 EDT
Description of problem:
Some of the output from systemd is unprintable when using a serial console.
I noticed this while testing Fedora 18 on ARM (a Pandaboard specifically).  I connected to the serial console with minicom, and then checked the status of NetworkManager and noticed:

[root@panda-f18-v7hl ~]# systemctl status NetworkManager.service
...
          CGroup: name=systemd:/system/NetworkManager.service
                  ��├ 461 /usr/sbin/NetworkManager --no-daemon
                  ��└ 725 /sbin/dhclient -d -4 -sf /usr/libexec/nm-dhcp-clie...

What are those '�' characters supposed to be?

If I ssh into the system and run the same command, I don't get the unprintable characters:

[root@panda-f18-v7hl ~]# systemctl status NetworkManager.service
...
	  CGroup: name=systemd:/system/NetworkManager.service
		  ├ 461 /usr/sbin/NetworkManager --no-daemon
		  └ 725 /sbin/dhclient -d -4 -sf /usr/libexec/nm-dhcp-clie...


Version-Release number of selected component (if applicable):
systemd-194-1.fc18.armv7hl

How reproducible:
every time

Steps to Reproduce:
1. connect to serial console of host with minicom
2. systemctl status NetworkManager.service
  
Actual results:
unprintable characters � in the output

Expected results:
no funny symbols

Additional info:
The $TERM is different on serial console vs ssh:

serial:
[root@panda-f18-v7hl ~]# echo $TERM
linux

ssh:
[root@panda-f18-v7hl ~]# echo $TERM
xterm-256color

Also, I do not have the $LESS variable set so this is not quite the same as bug 868383
Comment 1 Michal Schmidt 2012-10-29 15:03:00 EDT
(In reply to comment #0)
> serial:
> [root@panda-f18-v7hl ~]# echo $TERM
> linux

This is actually wrong. It's bug 870622. Not sure if fixing it could fix this bug too. We'll see.
Comment 2 Jeff Bastian 2012-10-29 15:25:23 EDT
Manually setting it did not help:

[root@panda-f18-v7hl ~]# TERM=vt102
[root@panda-f18-v7hl ~]# echo $TERM
vt102
[root@panda-f18-v7hl ~]# systemctl status NetworkManager.service
NetworkManager.service - Network Manager
          Loaded: loaded (/usr/lib/systemd/system/NetworkManager.service; enabled)
          Active: active (running) since Fri, 31 Dec 1999 19:00:22 -0500; 12 years and 9 months ago
        Main PID: 461 (NetworkManager)
          CGroup: name=systemd:/system/NetworkManager.service
                  ��├ 461 /usr/sbin/NetworkManager --no-daemon
                  ��└ 725 /sbin/dhclient -d -4 -sf /usr/libexec/nm-dhcp-clie...
...
Comment 3 Michal Schmidt 2012-10-29 19:15:37 EDT
This command will print similar characters:
printf '\x9\xe2\x94\x94\x20hello world\n'

It looks like a bug in minicom. It has a problem with UTF-8.
Try picocom instead.
Comment 4 Jeff Bastian 2012-10-30 09:43:52 EDT
picocom does indeed work better than minicom, thanks!

However, I know there are still many real (and ancient) VT100 terminals in data centers, and they are expecting clean 7-bit ASCII, so I wonder how they will respond to UTF-8 characters...
Comment 5 Jaromír Cápík 2012-10-31 06:07:16 EDT
Hello Jeff.

minicom should support switching between 7bit ASCII and 8bit RAW (pass through without any modification) ... Have you tried to play with switches ('-7' or '-8') ?

Please, let me know.

Thanks,
Jaromir.
Comment 6 Jeff Bastian 2012-10-31 10:13:15 EDT
It still prints the funny chars when using the -8 switch:
          CGroup: name=systemd:/system/NetworkManager.service
                  ��├ 466 /usr/sbin/NetworkManager --no-daemon
                  ��└ 685 /sbin/dhclient -d -4 -sf /usr/libexec/nm-dhcp-clie...


Switching to 7-bit makes it worse since I don't even get the line chars:
          CGroup: name=systemd:/system/NetworkManager.service
                  �.. 466 /usr/sbin/NetworkManager --no-daemon
                  �.. 685 /sbin/dhclient -d -4 -sf /usr/libexec/nm-dhcp-clie...


But even if the -7 or -8 bit switches worked, there are still plenty of real VT100 terminals in use, along with a number of serial console tools used by Windows and Macs that connect to server serial consoles in data centers, so it would be safest, IMHO, for a low-level tool like systemd to stick with clean 7-bit ASCII.
Comment 7 Michal Schmidt 2012-11-02 12:43:27 EDT
OK, upstream systemd will now print UTF-8 only in UTF-8 locales. There's a fallback to ugly ASCII:
http://cgit.freedesktop.org/systemd/systemd/commit/?id=c339d9775d1df19fdbbafc57486f7cd51af6b7fb
Comment 8 Fedora Update System 2013-01-14 09:09:37 EST
systemd-197-1.fc18.1 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/FEDORA-2013-0655/systemd-197-1.fc18.1
Comment 9 Fedora Update System 2013-01-19 22:33:12 EST
systemd-197-1.fc18.1 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 10 Jaromír Cápík 2013-01-24 13:55:58 EST
The passthrough mode doesn't seem to work correctly in minicom. Reopening.
Comment 11 Fedora End Of Life 2013-12-21 10:10:04 EST
This message is a reminder that Fedora 18 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 18. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '18'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 18's end of life.

Thank you for reporting this issue and we are sorry that we may not be 
able to fix it before Fedora 18 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior to Fedora 18's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 12 Fedora End Of Life 2015-01-09 17:01:24 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 13 Fedora End Of Life 2015-02-18 08:46:45 EST
Fedora 19 changed to end-of-life (EOL) status on 2015-01-06. Fedora 19 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 14 Jan Kurik 2015-07-15 10:57:43 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 23 development cycle.
Changing version to '23'.

(As we did not run this process for some time, it could affect also pre-Fedora 23 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 23 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora23

Note You need to log in before you can comment on or make changes to this bug.